<script lang="ts">
  import { afterUpdate, onMount } from "svelte";
  import { inputPattern } from "src/functions/input-pattern";
  import AlertConfirm from "src/widgets/AlertConfirm";
  import AlertMessage from "src/widgets/AlertMessage";
  import Pagination from "src/widgets/Pagination.svelte";
  import {
    formViewMode,
    pageSelectedStore,
    billOrderListStore,
    billOrderSelectedStore,
  } from "src/store";

  import { getBillOrderAPI } from "src/apis/get-bill-order";
  import type { BillOrderModel } from "src/models/bill.order.type";
  import BillStatus from "./BillStatus.svelte";
  import { convertFullTime } from "src/functions/convert-time-th";
  import DateSelect from "src/widgets/DateSelect.svelte";
  let billOrderPagination: BillOrderModel[] = [];

  let keyWord = "";
  let respSearch: BillOrderModel[] = [];
  let addressFindText = "";
  const searchPattern: any = {
    เลขบิล: "billId",
    รหัสผู้ซื้อ: "userId",
  };

  const statusBillList = [
    "ทั้งหมด",
    "สร้างรายการ",
    "จัดเตรียมของ",
    "กำลังจัดส่ง",
    "ได้รับแล้ว",
    "ยกเลิก",
  ];

  let searchBy = "เลขบิล";
  let searchBillStatus = "ทั้งหมด";
  let dataShowOnTable: BillOrderModel[] = [];
  let startDate: string;
  let endDate: string;

  onMount(async () => {
    await getBillOrderAPI();
  });

  $: {
    dataShowOnTable =
      respSearch.length && (keyWord || addressFindText || searchBillStatus)
        ? respSearch
        : keyWord == "" &&
          addressFindText == "" &&
          searchBillStatus == "ทั้งหมด"
        ? billOrderPagination
        : [];

    // เรียงวันล่าสุดไปไกลสุด
    dataShowOnTable = dataShowOnTable.sort(
      (a, b) => +new Date(`${b.createTime}`) - +new Date(`${a.createTime}`)
    );

    if (startDate && endDate) {
      dataShowOnTable = dataShowOnTable.filter(
        (data) =>
          +new Date(`${data.createTime}`) >= +new Date(startDate) &&
          +new Date(`${data.createTime}`) <= +new Date(endDate)
      );
    }
  }

  function numberWithCommas(x: number) {
    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
  }

  function findDataArray() {
    if (keyWord) {
      keyWord = keyWord.replace(/\\/g, "");
      let regex = new RegExp(keyWord, "g");
      respSearch = $billOrderListStore.filter((dt: any) => {
        if (dt[searchPattern[searchBy]]) {
          return dt[searchPattern[searchBy]].match(regex);
        }
      });
    } else {
      respSearch = [];
    }
  }

  function findDataBillStatusArray() {
    setTimeout(() => {
      if (searchBillStatus && searchBillStatus != "ทั้งหมด") {
        console.log(searchBy);
        searchBillStatus = searchBillStatus.replace(/\\/g, "");
        let regex = new RegExp(searchBillStatus, "g");
        respSearch = $billOrderListStore.filter((dt: any) =>
          dt.statusOrder.match(regex)
        );
      } else {
        respSearch = [];
      }
    }, 200);
  }
</script>

<div class="rounded h-full m-4">
  {#if $billOrderListStore.length > 0}
    <div id="tools" class="bg-gray-800 p-2 rounded">
      <div class="flex flex-wrap -mx-3 mb-2 justify-end items-center">
        <p class="text-white">ค้นหาโดย :</p>
        <div class="w-full md:w-1/6 px-3 mb-6 md:mb-0">
          <div class="">
            <select
              bind:value={searchBy}
              class="block w-full bg-gray-200 border
                border-gray-200 text-gray-700 py-3 px-4 pr-8 rounded leading-tight
                focus:outline-none focus:bg-white focus:border-gray-500"
              id="grid-state"
            >
              {#each Object.keys(searchPattern) as k}
                <option>{k}</option>
              {/each}
            </select>
          </div>
        </div>

        <div class="w-full md:w-3/6 px-3 mb-6 md:mb-0">
          <input
            bind:value={keyWord}
            on:keyup={() => findDataArray()}
            placeholder="ค้นหา"
            class="appearance-none block w-full py-3 px-4 leading-tight
              text-gray-700 bg-gray-200 focus:bg-white border border-gray-200
              focus:border-gray-500 rounded focus:outline-none pac-target-input"
          />
        </div>
      </div>
      <div class="flex flex-wrap -mx-3 mb-2 justify-end items-center">
        <div class="px-2 flex items-center border py-2 mx-2 rounded">
          <p class="text-white px-2">จาก</p>
          <DateSelect bind:dateString={startDate} />
          <p class="text-white px-2">ถึง</p>
          <DateSelect bind:dateString={endDate} />
          <button
            on:click={() => {
              startDate = "";
              endDate = "";
            }}
            class="bg-red-500 p-2 border border-white text-white">Clear</button
          >
        </div>
        <p class="text-white">สถานะจัดส่ง :</p>
        <div class="w-full md:w-1/6 px-3 mb-6 md:mb-0">
          <div class="">
            <select
              on:change={findDataBillStatusArray}
              bind:value={searchBillStatus}
              class="block w-full bg-gray-200 border
                border-gray-200 text-gray-700 py-3 px-4 pr-8 rounded leading-tight
                focus:outline-none focus:bg-white focus:border-gray-500"
              id="grid-state"
            >
              {#each statusBillList as k}
                <option>{k}</option>
              {/each}
            </select>
          </div>
        </div>
      </div>
      {#if respSearch.length == 0 && (keyWord || addressFindText || (startDate && endDate && respSearch.length == 0))}
        <p class="text-right px-2 text-red-500">* ไม่พบรายการบนฐานข้อมูล</p>
      {/if}
    </div>
    <div class="block w-full overflow-x-auto">
      <table
        class="table-auto w-full overflow-y-auto overflow-x-auto border rounded text-sm"
      >
        <thead class="bg-gray-100">
          <tr>
            <th class="px-4 py-2">#</th>
            <th class="px-4 py-2">วัน/เวลา</th>
            <th class="px-4 py-2">เลขบิล</th>
            <th class="px-4 py-2">รหัสผู้ซื้อ</th>
            <th class="px-4 py-2 truncate">รวมบิล</th>
            <th class="px-4 py-2">สถานะบิล</th>
            <th class="px-4 py-2 ">ชำระเงิน</th>
            <th class="px-4 py-2">ที่อยู่จัดส่ง</th>
          </tr>
        </thead>
        {#each dataShowOnTable as bill, index}
          <tbody>
            <tr class="bg-gray-100 hover:bg-gray-200">
              <td class="border px-2 py-2 text-gray-800">{index + 1}</td>
              <td class="border truncate px-2 py-2 text-gray-800"
                >
                {convertFullTime(bill.createTime)}
                </td>
              <td class="border px-2 py-2 text-gray-800"
                ><p class="truncate">{bill.billId}</p></td
              >
              <td class="border px-2 py-2 text-gray-800">{bill.userId}</td>
              <td
                class="border px-2 py-2 overflow-x-hidden text-center font-bold text-green-600"
              >
                {numberWithCommas(bill.sumPriceBill) || "-"}
              </td>
              <td class="border px-2 py-2 text-gray-800 text-center">
                <!-- {bill.statusOrder || "-"} -->
                <BillStatus bind:billData={bill} />
              </td>
              <td class="border p-2">
                <p
                  class="rounded-full text-center text-white {bill.statusPayment ==
                  'successful'
                    ? 'bg-green-600'
                    : 'bg-red-500'}"
                >
                  {(bill.statusPayment == "successful" ? "Y" : "N") || "-"}
                </p>
              </td>
              <td class="border px-2 py-2 text-gray-800 text-center">
                <div class="flex">
                  <p
                    class="flex truncate justify-center border rounded w-full h-20 items-center"
                  >
                    {bill.addressDelivery?.fullname}<br />
                    ที่อยู่: {bill.addressDelivery?.address} ตำบล{bill
                      .addressDelivery?.subdistrict} อำเภอ{bill.addressDelivery
                      ?.district} จังหวัด{bill.addressDelivery?.province}
                    <br />รหัสไปรษณีย์ {bill.addressDelivery?.zipcode}
                  </p>
                </div>
              </td>
            </tr>
          </tbody>
        {/each}
      </table>
    </div>
    <Pagination
      maxItemPerPage={10}
      bind:items={$billOrderListStore}
      bind:pageItemsCurrent={billOrderPagination}
    />
  {:else}
    <div class="h-full flex justify-center items-center">
      <p class="text-gray-500 text-xl text-right">
        ไม่พบรายการบนฐานข้อมูล
        <br />
        กรุณาเพิ่มข้อมูลสินค้าก่อน
      </p>
    </div>
  {/if}
</div>
